////////////////////////////////////////////////////////////////////////////////
//                            FCylinder.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef FCYLINDER_H
#define FCYLINDER_H

#include <X3DTK/kernel.h>

namespace X3DTK {

class FCylinder : public Cylinder
{
public:
  // Constructor.
  FCylinder();
  // Constructs a Cylinder from its attributes.
  FCylinder(SFBool bottom, 
            SFFloat radius, 
            SFFloat height, 
            SFBool side, 
            SFBool top,
            SFInt32 section);
  // Clones the node.
  virtual SFNode clone() const;  
  // sets the number of sections.
  void setSection(SFInt32 section);

  // gets the number of sections.
  inline SFInt32 getSection() const {return _section;};
  
  // Loads the attributes from a X3DFileElement e.
  virtual void loadAttributes(const X3DFileElement *element);
  // Writes the attributes of the node.
  virtual SFString writeAttributes() const;

protected:
  // Copy constructor.	   
  FCylinder(const FCylinder &C);

private:
  SFInt32 _section;
};

}

#endif
