#include "MyGLUpdaterGLGeometry3DVisitor.h"
#include "GLFCylinder.h"
#include "FCylinder.h"

using namespace X3DTK;

MyGLUpdaterGLGeometry3DVisitor::MyGLUpdaterGLGeometry3DVisitor()
: GLUpdaterGLGeometry3DVisitor()
{
  // Define new enter function for the GLFCylinder.
  defineNewEnterFunction<MyGLUpdaterGLGeometry3DVisitor, GLFCylinder>(&MyGLUpdaterGLGeometry3DVisitor::enterGLFCylinder);
}

void MyGLUpdaterGLGeometry3DVisitor::enterGLFCylinder(GLFCylinder *G) const
{
  // Update of the GLFCylinder.
  // Get the link.
  FCylinder *C = static_cast<FCylinder *>(G->getLink());
  
  // update the attributes.
  G->getBottom() = C->getBottom();
  G->getRadius() = C->getRadius();
  G->getHeight() = C->getHeight();
  G->getSide() = C->getSide();
  G->getTop() = C->getTop();
  // Get the instance of CylinderDrawArray.
  G->getCylinderDrawArray() = CylinderDrawArray::getInstanceOfSection(C->getSection());
}
