////////////////////////////////////////////////////////////////////////////////
//  generated by script                                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DKERNEL_H
#define X3DKERNEL_H

//Component
#include "private/CoreCreator.h"
#include "private/CoreVisitor.h"
#include "private/CoreWalker.h"
#include "private/DefaultCoreCreator.h"
#include "private/DefaultGeometry3DCreator.h"
#include "private/DefaultGroupingCreator.h"
#include "private/DefaultNodeCreationProxy.h"
#include "private/DefaultRenderingCreator.h"
#include "private/DefaultShapeCreator.h"
#include "private/DefaultTexturingCreator.h"
#include "private/Geometry3DCreator.h"
#include "private/Geometry3DVisitor.h"
#include "private/Geometry3DWalker.h"
#include "private/GroupingCreator.h"
#include "private/GroupingVisitor.h"
#include "private/GroupingWalker.h"
#include "private/RenderingCreator.h"
#include "private/RenderingVisitor.h"
#include "private/RenderingWalker.h"
#include "private/RootCreator.h"
#include "private/RootVisitor.h"
#include "private/RootWalker.h"
#include "private/ShapeCreator.h"
#include "private/ShapeVisitor.h"
#include "private/ShapeWalker.h"
#include "private/TexturingCreator.h"
#include "private/TexturingVisitor.h"
#include "private/TexturingWalker.h"

//GLComponent
#include "private/GLCoreVisitor.h"
#include "private/GLCoreWalker.h"
#include "private/GLGeometry3DVisitor.h"
#include "private/GLGeometry3DWalker.h"
#include "private/GLGroupingVisitor.h"
#include "private/GLGroupingWalker.h"
#include "private/GLRenderingVisitor.h"
#include "private/GLRenderingWalker.h"
#include "private/GLShapeVisitor.h"
#include "private/GLShapeWalker.h"
#include "private/GLTexturingVisitor.h"
#include "private/GLTexturingWalker.h"

//Loader
#include "private/DefaultLoader.h"
#include "private/X3DLoader.h"
#include "private/XercesLoader.h"

//NodeProxy
#include "private/CreationFunction.h"
#include "private/EnterFunction.h"
#include "private/LeaveFunction.h"
#include "private/NodeCreationProxy.h"
#include "private/NodeVisitingProxy.h"
#include "private/NodeWalkingProxy.h"

//Type
#include "private/Component.h"
#include "private/Type.h"
#include "private/VisitingFunctions.h"
#include "private/WalkOnFunction.h"
#include "private/WalkingFunction.h"

//X3DAbstractNode
#include "private/X3DAbstractNode.h"
#include "private/X3DActiveFunction.h"

//X3DComponent
#include "private/X3DComponent.h"
#include "private/X3DComponentCreator.h"
#include "private/X3DComponentVisitor.h"
#include "private/X3DComponentWalker.h"
#include "private/X3DFunction.h"
#include "private/X3DNodeProxy.h"

//TTAlgorithm
#include "private/DFS.h"
#include "private/DFSCoreWalker.h"
#include "private/DFSGLCoreWalker.h"
#include "private/DFSGLGeometry3DWalker.h"
#include "private/DFSGLGroupingWalker.h"
#include "private/DFSGLRenderingWalker.h"
#include "private/DFSGLShapeWalker.h"
#include "private/DFSGLTexturingWalker.h"
#include "private/DFSGeometry3DWalker.h"
#include "private/DFSGroupingWalker.h"
#include "private/DFSRenderingWalker.h"
#include "private/DFSShapeWalker.h"
#include "private/DFSTexturingWalker.h"
#include "private/DefaultDFS.h"
#include "private/DefaultDFSCoreWalker.h"
#include "private/DefaultDFSGeometry3DWalker.h"
#include "private/DefaultDFSGroupingWalker.h"
#include "private/DefaultDFSRenderingWalker.h"
#include "private/DefaultDFSShapeWalker.h"
#include "private/DefaultDFSTexturingWalker.h"
#include "private/DefaultGLDFS.h"
#include "private/DefaultGLDFSGLCoreWalker.h"
#include "private/DefaultGLDFSGLGeometry3DWalker.h"
#include "private/DefaultGLDFSGLGroupingWalker.h"
#include "private/DefaultGLDFSGLRenderingWalker.h"
#include "private/DefaultGLDFSGLShapeWalker.h"
#include "private/DefaultGLDFSGLTexturingWalker.h"

//DefaultX3DProcessors
#include "private/X3DBboxUpdater.h"
#include "private/X3DGLCreator.h"
#include "private/X3DGLRenderer.h"
#include "private/X3DGLUpdater.h"
#include "private/X3DMemReleaser.h"
#include "private/X3DSceneToFile.h"
#include "private/GVManager.h"
#include "private/GlobalVariables.h"
#include "private/X3DOnePassProcessor.h"
#include "private/X3DProcessor.h"
#include "private/X3DTTAlgorithm.h"

//X3DGLNodes

//GLCore
#include "private/GLCoreNodes.h"
#include "private/GLScene.h"
#include "private/X3DGLNode.h"

//GLGeometry3D
#include "private/BoxDrawArray.h"
#include "private/ConeDrawArray.h"
#include "private/CylinderDrawArray.h"
#include "private/GLBox.h"
#include "private/GLCone.h"
#include "private/GLCylinder.h"
#include "private/GLGeometry3DNodes.h"
#include "private/GLIndexedFaceSet.h"
#include "private/GLSphere.h"
#include "private/SphereDrawArray.h"

//GLGrouping
#include "private/GLGroup.h"
#include "private/GLGroupingNodes.h"
#include "private/GLStaticGroup.h"
#include "private/GLTransform.h"
#include "private/X3DGLChildNode.h"
#include "private/X3DGLGroupingNode.h"

//GLRendering
#include "private/GLIndexedLineSet.h"
#include "private/GLPointSet.h"
#include "private/GLRenderingNodes.h"
#include "private/GLTriangleFanSet.h"
#include "private/GLTriangleSet.h"
#include "private/GLTriangleStripSet.h"
#include "private/X3DGLComposedGeometryNode.h"
#include "private/X3DGLGeometry3DNode.h"
#include "private/X3DGLGeometryNode.h"

//GLShape
#include "private/GLAppearance.h"
#include "private/GLFillProperties.h"
#include "private/GLLineProperties.h"
#include "private/GLMaterial.h"
#include "private/GLShape.h"
#include "private/GLShapeNodes.h"
#include "private/X3DGLAppearanceChildNode.h"
#include "private/X3DGLAppearanceNode.h"
#include "private/X3DGLMaterialNode.h"
#include "private/X3DGLShapeNode.h"

//GLTexturing
#include "private/GLImageTexture.h"
#include "private/GLTexturingNodes.h"
#include "private/X3DGLTexture2DNode.h"
#include "private/X3DGLTextureNode.h"
#include "private/X3DGLTextureTransformNode.h"

//X3DListener
#include "private/X3DListener.h"

//X3DNodes

//Core
#include "private/CoreNodes.h"
#include "private/Scene.h"
#include "private/X3DNameDict.h"
#include "private/X3DNode.h"
#include "private/X3DObject.h"

//FileElement
#include "private/FileElement.h"
#include "private/QFileElement.h"
#include "private/X3DFileElement.h"
#include "private/XercesFileElement.h"

//Geometry3D
#include "private/Box.h"
#include "private/Cone.h"
#include "private/Cylinder.h"
#include "private/Geometry3DNodes.h"
#include "private/IndexedFaceSet.h"
#include "private/Sphere.h"

//Grouping
#include "private/Group.h"
#include "private/GroupingNodes.h"
#include "private/StaticGroup.h"
#include "private/Transform.h"
#include "private/X3DBoundedObject.h"
#include "private/X3DChildNode.h"
#include "private/X3DGroupingNode.h"

//Rendering
#include "private/Color.h"
#include "private/ColorRGBA.h"
#include "private/Coordinate.h"
#include "private/IndexedLineSet.h"
#include "private/Normal.h"
#include "private/PointSet.h"
#include "private/RenderingNodes.h"
#include "private/TriangleFanSet.h"
#include "private/TriangleSet.h"
#include "private/TriangleStripSet.h"
#include "private/X3DColorNode.h"
#include "private/X3DComposedGeometryNode.h"
#include "private/X3DCoordinateNode.h"
#include "private/X3DGeometricPropertyNode.h"
#include "private/X3DGeometry3DNode.h"
#include "private/X3DGeometryNode.h"
#include "private/X3DNormalNode.h"

//Shape
#include "private/Appearance.h"
#include "private/FillProperties.h"
#include "private/LineProperties.h"
#include "private/Material.h"
#include "private/Shape.h"
#include "private/ShapeNodes.h"
#include "private/X3DAppearanceChildNode.h"
#include "private/X3DAppearanceNode.h"
#include "private/X3DMaterialNode.h"
#include "private/X3DShapeNode.h"

//Texturing
#include "private/ImageTexture.h"
#include "private/TextureCoordinate.h"
#include "private/TexturingNodes.h"
#include "private/X3DTexture2DNode.h"
#include "private/X3DTextureCoordinateNode.h"
#include "private/X3DTextureNode.h"
#include "private/X3DTextureTransformNode.h"

//X3DTypes
#include "private/Bbox.h"
#include "private/SFMatrix34f.h"
#include "private/SFPoint3f.h"
#include "private/SFString.h"
#include "private/SFVec3f.h"
#include "private/X3DBaseTypes.h"
#include "private/X3DGLTypes.h"
#include "private/X3DTypes.h"
#include "private/X3DTypesToSFString.h"

#endif
