////////////////////////////////////////////////////////////////////////////////
//                            BboxUpdaterRenderingVisitor.h                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXUPDATERRENDERINGVISITOR_H
#define BBOXUPDATERRENDERINGVISITOR_H

#include "RenderingVisitor.h"
#include "BboxUpdaterGlobalVariables.h"

namespace X3DTK {

class Coordinate;
class X3DGeometryNode;

/// Visitor for the Rendering component of the BboxUpdater module.

class BboxUpdaterRenderingVisitor : public RenderingVisitor
{
public:
  /// Constructor.
  BboxUpdaterRenderingVisitor();
  /// Destructor.
  virtual ~BboxUpdaterRenderingVisitor();

  /// Enters a Coordinate.
  virtual void enterCoordinate(Coordinate *C) const;

  /// Walks on a X3DGeometryNode.
  virtual bool walkOnX3DGeometryNode(X3DGeometryNode *N, SFNode Child) const;


protected:
  BboxUpdaterGlobalVariables *globalVariables;
};

}

#endif
