////////////////////////////////////////////////////////////////////////////////
//                            DFS.h                                           //
////////////////////////////////////////////////////////////////////////////////

#ifndef DFS_H
#define DFS_H

#include "X3DTypes.h"
#include "X3DTTAlgorithm.h"

namespace X3DTK {

/// Abstract class defining the concept of tree traversal algorithm depth first search.

class DFS : public X3DTTAlgorithm
{
public:
  /// Constructor.
  DFS();
  /// Destructor.  
  virtual ~DFS();
  
  /// Joins the content of D1 and D2.
  friend DFS *joinDFS(DFS *D1, DFS *D2);
  /// Merges the content of D1 and D2 and deletes D1 and D2.  
  friend DFS *mergeDFS(DFS *D1, DFS *D2);
};

}

#endif
