////////////////////////////////////////////////////////////////////////////////
//                            DefaultGLDFSGLGroupingWalker.h                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTGLDFSGLGROUPINGWALKER_H
#define DEFAULTGLDFSGLGROUPINGWALKER_H

#include "DFSGLGroupingWalker.h"
#include "GLGroupingNodes.h"

namespace X3DTK {

class GLStaticGroup;
class X3DGLGroupingNode;

/// Concrete component walker for the Grouping component.

class DefaultGLDFSGLGroupingWalker : public DFSGLGroupingWalker
{
public:
  /// Constructor.
  DefaultGLDFSGLGroupingWalker();
  /// Destructor.
  virtual ~DefaultGLDFSGLGroupingWalker();
  
  /// Walks a StaticGroup.
  virtual void walkGLStaticGroup(GLStaticGroup *G) const;
  /// Walks a X3DGroupingNode.
  virtual void walkX3DGLGroupingNode(X3DGLGroupingNode *N) const;
};

}

#endif
