////////////////////////////////////////////////////////////////////////////////
//                            DefaultGLDFSGLRenderingWalker.h                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTGLDFSGLRENDERINGWALKER_H
#define DEFAULTGLDFSGLRENDERINGWALKER_H

#include "DFSGLRenderingWalker.h"
#include "GLRenderingNodes.h"

namespace X3DTK {

class X3DGLComposedGeometryNode;
class GLIndexedLineSet;
class GLPointSet;

/// Concrete component walker for the Rendering component.

class DefaultGLDFSGLRenderingWalker : public DFSGLRenderingWalker
{
public:
  /// Constructor.
  DefaultGLDFSGLRenderingWalker();
  /// Destructor.
  virtual ~DefaultGLDFSGLRenderingWalker();
  
  virtual void walkX3DGLComposedGeometryNode(X3DGLComposedGeometryNode *N) const;
  virtual void walkGLIndexedLineSet(GLIndexedLineSet *I) const;
  virtual void walkGLPointSet(GLPointSet *P) const;
};

}

#endif
