////////////////////////////////////////////////////////////////////////////////
//                            DefaultTexturingCreator.h                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTTEXTURINGCREATOR_H
#define DEFAULTTEXTURINGCREATOR_H

#include "TexturingCreator.h"

namespace X3DTK {

/// Concrete component Creator for the Texturing component defining the default 
/// X3D nodes.

class DefaultTexturingCreator : public TexturingCreator
{
public:
  /// Constructor.
  DefaultTexturingCreator();
  /// Destructor.
  virtual ~DefaultTexturingCreator();
  
  /// Creates an ImageTexture.  
  SFNode createImageTexture() const;
  /// Creates a TextureCoordinate.
  SFNode createTextureCoordinate() const;
};

}

#endif
