////////////////////////////////////////////////////////////////////////////////
//                            EnterFunction.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef ENTERFUNCTION_H
#define ENTERFUNCTION_H

#include "X3DActiveFunction.h"
#include "X3DTypes.h"

namespace X3DTK {

/// Abstract class defining the concept of enter function implemented by a functor.

class EnterFunction : public X3DActiveFunction
{
public:
  /// Constructor.
  EnterFunction(const ptrToEnterFunction enter, const X3DComponentVisitor *component);
  /// Destructor.
  ~EnterFunction();
  
  /// Enter the node.
  inline void enter(SFNode N) const {(component_->*ptr2enter_)(N);};
  
private:
  const ptrToEnterFunction ptr2enter_;
  const X3DComponentVisitor *component_;
};

}

#endif
