////////////////////////////////////////////////////////////////////////////////
//                            GLBox.h                                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBOX_H
#define GLBOX_H

#include "X3DGLGeometry3DNode.h"

namespace X3DTK {

class Box;
class BoxDrawArray;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode Box.

class GLBox : public X3DGLGeometry3DNode
{
public:
  /// Constructor.
  GLBox();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLBox();
  
  /// Gets the size.
  inline SFVec3f &getSize() const {return (SFVec3f &)_size;};
  /// Gets the box array.
  inline BoxDrawArray *&getBoxDrawArray() const {return (BoxDrawArray *&)_boxArray;};

protected:     
  /// Copy constructor.
  GLBox(const GLBox &B);
  
private:
  //GL attributes
  SFVec3f _size;
  BoxDrawArray *_boxArray;
};

}

#endif
