////////////////////////////////////////////////////////////////////////////////
//                            GLCone.h                                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCONE_H
#define GLCONE_H

#include "X3DGLGeometry3DNode.h"

namespace X3DTK {

class Cone;
class ConeDrawArray;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode
/// Cone.

class GLCone : public X3DGLGeometry3DNode
{
public:
  /// Constructor.
  GLCone();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLCone();

  /// Gets the radius.
  SFFloat &getBottomRadius() const {return (SFFloat &)_bottomRadius;};
  /// Gets the height.
  SFFloat &getHeight() const {return (SFFloat &)_height;};
  /// Gets the side.
  SFBool &getSide() const {return (SFBool &)_side;};
  /// Gets the bottom.
  SFBool &getBottom() const {return (SFBool &)_bottom;};
  /// Gets the ConeDrawArray.
  inline ConeDrawArray *&getConeDrawArray() const {return (ConeDrawArray *&)_coneArray;};

protected:
  /// Copy constructor.	   
  GLCone(const GLCone &C);
  
private:
  //GL attributes
  SFFloat _bottomRadius;
  SFFloat _height;
  SFBool _side;
  SFBool _bottom;
  ConeDrawArray *_coneArray;
};

}

#endif
