////////////////////////////////////////////////////////////////////////////////
//                            GLCoreVisitor.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCOREVISITOR_H
#define GLCOREVISITOR_H

#include "X3DComponentVisitor.h"
#include "X3DGLNode.h"

namespace X3DTK {

class NodeCreationProxy;

/// Concrete component Visitor for the GLCore component.

class GLCoreVisitor : public X3DComponentVisitor
{
public:
  /// Constructor.
  GLCoreVisitor();
  /// Destructor.
  virtual ~GLCoreVisitor();
  
  /// Enters an X3DGLNode.
  virtual void enterX3DGLNode(X3DGLNode *N) const;
  /// Walks on an X3DGLNode.
  virtual bool walkOnX3DGLNode(X3DGLNode *N, SFNode child) const;
  /// Enters an X3DGLNode.
  virtual void leaveX3DGLNode(X3DGLNode *N) const;
};

}

#endif
