////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorGlobalVariables.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORGLOBALVARIABLES_H
#define GLCREATORGLOBALVARIABLES_H

#include "GlobalVariables.h"

#include "GLScene.h"

namespace X3DTK {

/// GlobalVariables for the GLCreator module.

class GLCreatorGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  GLCreatorGlobalVariables();
  /// Destructor.
  virtual ~GLCreatorGlobalVariables();
  
  /// Sets the GLScene.
  void setGLScene(GLScene *S);
  /// Pushes the node.
  void pushNode(GLSFNode N);
  /// Pops the node.
  void popNode();
    
  /// Gets the GLScene.
  inline GLScene *getGLScene() const {return _glscene;};
  /// Gets the top of the stack.
  inline GLSFNode getTop() const {return _nodeStack.front();};
  
private:
  GLScene *_glscene;
  GLMFNode _nodeStack;  
};

}

#endif
