////////////////////////////////////////////////////////////////////////////////
//                            GLRendererGLRenderingVisitor.h                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERERGLRENDERINGVISITOR_H
#define GLRENDERERGLRENDERINGVISITOR_H

#include "GLRenderingVisitor.h"
#include "GLRendererGlobalVariables.h"

namespace X3DTK {

class GLIndexedLineSet;
class GLPointSet;
class GLTriangleFanSet;
class GLTriangleSet;
class GLTriangleStripSet;

/// Visitor for the GLRendering component of the GLRenderer module.

class GLRendererGLRenderingVisitor : public GLRenderingVisitor
{
public:
  /// Constructor.
  GLRendererGLRenderingVisitor();
  /// Destructor.
  virtual ~GLRendererGLRenderingVisitor();

  /// Enters a GLIndexedLineSet.
  virtual void enterGLIndexedLineSet(GLIndexedLineSet *G) const;
  /// Enters a GLPointSet.
  virtual void enterGLPointSet(GLPointSet *G) const;
  /// Enters a GLTriangleFanSet.
  virtual void enterGLTriangleFanSet(GLTriangleFanSet *G) const;
  /// Enters a GLTriangleSet.
  virtual void enterGLTriangleSet(GLTriangleSet *G) const;
  /// Enters a GLTriangleStripSet.
  virtual void enterGLTriangleStripSet(GLTriangleStripSet *G) const;



protected:
  GLRendererGlobalVariables *globalVariables;
};

}

#endif
