////////////////////////////////////////////////////////////////////////////////
//                            GLTransform.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLTRANSFORM_H
#define GLTRANSFORM_H

#include "X3DGLGroupingNode.h"

#include <vector>

namespace X3DTK {

class Transform;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// Transform.

class GLTransform : public X3DGLGroupingNode
{
public:  
  /// Constructor.
  GLTransform();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  ~GLTransform();

  /// Gets the transform matrix.
  MFFloat &getTransformMatrix() const {return (MFFloat &)_transformMatrix;};

protected:
  /// Copy constructor.	             
  GLTransform(const GLTransform &T);
  
private:                                                         
  //GL attributes
  MFFloat _transformMatrix;
};

}

#endif
