////////////////////////////////////////////////////////////////////////////////
//                            GLUpdaterGLGeometry3DVisitor.h                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLUPDATERGLGEOMETRY3DVISITOR_H
#define GLUPDATERGLGEOMETRY3DVISITOR_H

#include "GLGeometry3DVisitor.h"
#include "GLUpdaterGlobalVariables.h"

namespace X3DTK {

class GLBox;
class GLCone;
class GLCylinder;
class GLIndexedFaceSet;
class GLSphere;

/// Visitor for the GLGeometry3D component of the GLUpdater module.

class GLUpdaterGLGeometry3DVisitor : public GLGeometry3DVisitor
{
public:
  /// Constructor.
  GLUpdaterGLGeometry3DVisitor();
  /// Destructor.
  virtual ~GLUpdaterGLGeometry3DVisitor();

  /// Enters a GLBox.
  virtual void enterGLBox(GLBox *G) const;
  /// Enters a GLCone.
  virtual void enterGLCone(GLCone *G) const;
  /// Enters a GLCylinder.
  virtual void enterGLCylinder(GLCylinder *G) const;
  /// Enters a GLIndexedFaceSet.
  virtual void enterGLIndexedFaceSet(GLIndexedFaceSet *G) const;
  /// Enters a GLSphere.
  virtual void enterGLSphere(GLSphere *G) const;



protected:
  GLUpdaterGlobalVariables *globalVariables;
  
  void computeNoColor_NoTexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeColor_NoTexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeNoColor_TexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeColor_TexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeArrays(GLIndexedFaceSet *G, MFVec3f &vertexArray, MFVec3f &normalArray, MFInt32 &coordIndex) const;
};

}

#endif
