////////////////////////////////////////////////////////////////////////////////
//                            ImageTexture.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef IMAGETEXTURE_H
#define IMAGETEXTURE_H

#include "X3DTexture2DNode.h"

namespace X3DTK {

/// \addtogroup Texturing
/// @{

/// Class of the <a href="../../doc/X3D_Specs/Part01/components/texturing.html">
/// Texturing component</a> defining an ImageTexture
/// (<a href="../../doc/X3D_Specs/Part01/components/texturing.html#ImageTexture">
/// X3D documentation</a>).

class ImageTexture : public X3DTexture2DNode
{
public:  
  /// Constructor.
  ImageTexture();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  ~ImageTexture();
  
  /// Sets the url attribute.
  void setUrl(const MFString &url);
  
  /// Gets the url attribute.
  inline MFString getUrl() const {return url_;};
  
  /// Loads the attributes from a FileElement.
  virtual void loadAttributes(const X3DFileElement *element);
  /// Writes the attributes of the node.
  virtual SFString writeAttributes() const;

protected:  
  /// Copy constructor.	
  ImageTexture(const ImageTexture &N);
  
private:
  MFString url_;  
};

}

#endif
