////////////////////////////////////////////////////////////////////////////////
//                            MemReleaserRootVisitor.h                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef MEMRELEASERROOTVISITOR_H
#define MEMRELEASERROOTVISITOR_H

#include "RootVisitor.h"
#include "MemReleaserGlobalVariables.h"

namespace X3DTK {

class Scene;
class X3DNode;

/// Visitor for the Root component of the MemReleaser module.

class MemReleaserRootVisitor : public RootVisitor
{
public:
  /// Constructor.
  MemReleaserRootVisitor();
  /// Destructor.
  virtual ~MemReleaserRootVisitor();

  /// Enters a X3DNode.
  virtual void enterX3DAbstractNode(X3DAbstractNode *N) const;

  /// Enters a X3DNode.
  virtual void leaveX3DAbstractNode(X3DAbstractNode *N) const;

protected:
  MemReleaserGlobalVariables *globalVariables;
};

}

#endif
