////////////////////////////////////////////////////////////////////////////////
//                            QFileElement.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef QFILEELEMENT_H
#define QFILEELEMENT_H

#include "X3DFileElement.h"

#include <qstring.h>
#include <qxml.h>

namespace X3DTK {

class QFileElement : public X3DFileElement
{
public:
  /// Constructor.
  QFileElement();
  /// Constructor with parameters.
  QFileElement(const QString &name, const QXmlAttributes &attributes);
  /// Destructor.
  ~QFileElement();

  /// Sets the name.
  void setName(const QString &name);
  /// Sets the attributes.
  void setAttributes(const QXmlAttributes &attributes);
  
  /// Gets the name.
  SFString getName() const;
  /// Gets the attribute at the index i.
  SFString getAttribute(int i) const;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  int getIndexAttribute(const SFString &attribute) const;
  
private:
  QString name_;
  QXmlAttributes attributes_;
};

}

#endif
