////////////////////////////////////////////////////////////////////////////////
//                            SFString.h                                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef SFSTRING_H
#define SFSTRING_H

#include <string>

namespace X3DTK {

class SFString : public std::string
{
public:
  SFString();
  SFString(const char *s);
  SFString(const std::string &s);
  SFString(const SFString &s);
  
  operator const char *() const;
  
  int toInt() const;
  unsigned int toUint() const;
  float toFloat() const;
  double toDouble() const;
  SFString lower() const;
  SFString upper() const;
  
  SFString getPath() const;
    
  static SFString number(float f);
  static SFString number(double d);
  static SFString number(int i); 
  static SFString number(unsigned int ui); 
};

}

#endif
