////////////////////////////////////////////////////////////////////////////////
//                            SceneToFileCoreVisitor.h                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef SCENETOFILECOREVISITOR_H
#define SCENETOFILECOREVISITOR_H

#include "CoreVisitor.h"
#include "SceneToFileGlobalVariables.h"

namespace X3DTK {

class Scene;
class X3DNode;

/// Visitor for the Core component of the SceneToFile module.

class SceneToFileCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  SceneToFileCoreVisitor();
  /// Destructor.
  virtual ~SceneToFileCoreVisitor();

  /// Enters a X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;


  /// Walks on a X3DNode.
  virtual bool walkOnX3DNode(X3DNode *N, SFNode Child) const;

  /// Enters a X3DNode.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  SceneToFileGlobalVariables *globalVariables;
};

}

#endif
