////////////////////////////////////////////////////////////////////////////////
//                            X3DAppearanceNode.h                             //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef X3DAPPEARANCENODE_H
#define X3DAPPEARANCENODE_H

#include "X3DNode.h"

namespace X3DTK {

/// \addtogroup Shape
/// @{

/// Base class of the <a href="../../doc/X3D_Specs/Part01/components/shape.html">Shape 
/// component</a> defining an X3DAppearanceNode
/// (<a href="../../doc/X3D_Specs/Part01/components/Shape.html#X3DAppearanceNode">
/// X3D documentation</a>).


class X3DAppearanceNode : public X3DNode
{
public:
  /// Constructor.
  X3DAppearanceNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DAppearanceNode();
  
protected:
  /// Copy constructor.
  X3DAppearanceNode(const X3DAppearanceNode &N);
};

}

#endif
