////////////////////////////////////////////////////////////////////////////////
//                            X3DColorNode.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DCOLORNODE_H
#define X3DCOLORNODE_H

#include "X3DGeometricPropertyNode.h"

namespace X3DTK {

/// Base class of the <a href="../../doc/X3D_Specs/Part01/components/rendering.html">
/// Rendering component</a> defining an X3DColorNode
/// (<a href="../../doc/X3D_Specs/Part01/components/rendering.html#X3DColorNode">
/// X3D documentation</a>).

class X3DColorNode : public X3DGeometricPropertyNode
{
public:  
  /// Constructor.
  X3DColorNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DColorNode();

protected:
  /// Copy constructor. 
  X3DColorNode(const X3DColorNode &N);
};

}

#endif
