////////////////////////////////////////////////////////////////////////////////
//                            X3DFileElement.h                                //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DFILEELEMENT_H
#define X3DFILEELEMENT_H

#include "X3DTypes.h"

namespace X3DTK {

class X3DFileElement
{
public:
  /// Constructor.
  X3DFileElement();
  /// Destructor.
  virtual ~X3DFileElement() = 0;

  /// Gets the name.
  virtual SFString getName() const = 0;
  /// Gets the attribute at the index i.
  virtual SFString getAttribute(int i) const = 0;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  virtual int getIndexAttribute(const SFString &attribute) const = 0;
};

}

#endif
