////////////////////////////////////////////////////////////////////////////////
//                            X3DGLGroupingNode.h                             //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef X3DGLGROUPINGNODE
#define X3DGLGROUPINGNODE

#include "X3DGLChildNode.h"

namespace X3DTK {

class X3DGLGroupingNode : public X3DGLChildNode
{
public:
  /// Constructor.
  X3DGLGroupingNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DGLGroupingNode();

  /// Adds a child to the Children attribute. Return TRUE if succeeds.
  virtual bool addChild(const SFNode &N);
  /// Sets the child. Behaves like addChild.
  virtual bool setChild(const SFNode &N);
  /// Removes the child. Return TRUE if succeeds.
  virtual bool removeChild(const SFNode &N);
  
  /// Gets the Children attribute.
  inline MFNode getChildren() const {return _children;};

protected:
  /// Copy constructor.		  
  X3DGLGroupingNode(const X3DGLGroupingNode &N);

  /// Children attribute.
  MFNode _children;
};

}

#endif
