////////////////////////////////////////////////////////////////////////////////
//                            X3DGLTypes.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGLTYPES_H
#define X3DGLTYPES_H

#include <list>
#include <vector>

namespace X3DTK {

class X3DGLNode;
/// GLSFNode class representing a node specialized in GL rendering
typedef X3DGLNode *GLSFNode; 
/// GLMFNode class providing multiple GLSFNode
typedef std::list<GLSFNode> GLMFNode;

typedef struct
{
  SFColorRGBA color;
  SFVec3f normal;
  SFVec3f vertex;
} C4F_N3F_V3F;

typedef struct 
{
  SFVec3f normal;
  SFVec3f vertex;
} N3F_V3F;
  
typedef struct
{
  SFVec2f texCoord;
  SFColorRGBA color;
  SFVec3f normal;
  SFVec3f vertex;
} T2F_C4F_N3F_V3F;

typedef struct 
{
  SFVec2f texCoord;
  SFVec3f normal;
  SFVec3f vertex;
} T2F_N3F_V3F;

typedef struct
{
  unsigned char r, g, b, a;
  SFVec3f vertex;
} C4UB_V3F;


}

#endif
