////////////////////////////////////////////////////////////////////////////////
//                            X3DGeometry3DNode.h                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGEOMETRY3DNODE_H
#define X3DGEOMETRY3DNODE_H

#include "X3DGeometryNode.h"

namespace X3DTK {

/// Base class of the <a href="../../doc/X3D_Specs/Part01/components/rendering.html">
/// Rendering component</a> defining an X3DGeometry3DNode
/// (<a href="../../doc/X3D_Specs/Part01/components/rendering.html#X3DGeometry3DNode">
/// X3D documentation</a>).

class X3DGeometry3DNode : public X3DGeometryNode
{
public:  
  /// Constructor.
  X3DGeometry3DNode();
  /// Clones the node.
  SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DGeometry3DNode();

protected:
  /// Constructs an X3DGeometry3DNode from its attributes.
  X3DGeometry3DNode(const X3DGeometry3DNode &N);  
};

}

#endif
