////////////////////////////////////////////////////////////////////////////////
//                            X3DGeometryNode.h                               //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGEOMETRYNODE_H
#define X3DGEOMETRYNODE_H

#include "X3DNode.h"

namespace X3DTK {

/// Base class of the <a href="../../doc/X3D_Specs/Part01/components/rendering.html">
/// Rendering component</a> defining an X3DGeometryNode
/// (<a href="../../doc/X3D_Specs/Part01/components/rendering.html#X3DGeometryNode">
/// X3D documentation</a>).

class X3DGeometryNode : public X3DNode
{
public:  
  /// Constructor
  X3DGeometryNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DGeometryNode();
  
protected:
  /// Constructs an X3DGeometryNode from its attributes.
  X3DGeometryNode(const X3DGeometryNode &N);
};

}

#endif
