////////////////////////////////////////////////////////////////////////////////
//                            X3DListener.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DLISTENER_H
#define X3DLISTENER_H

#include "X3DTypes.h"

namespace X3DTK {

/// Base class providing an interface for an X3D listener.

class X3DListener
{
public:
  X3DListener();
  virtual ~X3DListener();
  
  void pushAddedNode(SFNode N);
  SFNode popAddedNode();
  
  void pushRemovedNode(SFNode N);
  SFNode popRemovedNode();

  void pushAddedLink(SFNodeLink L);
  SFNodeLink popAddedLink();
  
  void pushRemovedLink(SFNodeLink L);
  SFNodeLink popRemovedLink();

protected:
  MFNode addedNodes;
  MFNode removedNodes;
  MFDNode addedLinks;
  MFDNode removedLinks;
};

}

#endif
