////////////////////////////////////////////////////////////////////////////////
//                            X3DLoader.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DLOADER_H
#define X3DLOADER_H

#include "X3DTypes.h"

namespace X3DTK {

class Scene;
class NodeCreationProxy;

/// Abstract class defining an interface for an X3D file loader.

class X3DLoader
{
public:
  /// Constructor.
  X3DLoader();
  /// Destructor.
  virtual ~X3DLoader() = 0;
  
  /// Sets the componentVisitor.
  void setComponentCreator(X3DComponentCreator *component);
  
  /// Loads a scene from the file.
  virtual Scene *load(const char *file, bool fileValidation = false) const = 0;

protected:
  NodeCreationProxy *ncp;
  
};

}

#endif
