#include "DefaultGroupingCreator.h"
#include "GroupingNodes.h"

using namespace X3DTK;

DefaultGroupingCreator::DefaultGroupingCreator()
{
  defineNewCreationFunction<DefaultGroupingCreator>("Group", &DefaultGroupingCreator::createGroup);
  defineNewCreationFunction<DefaultGroupingCreator>("StaticGroup", &DefaultGroupingCreator::createStaticGroup);
  defineNewCreationFunction<DefaultGroupingCreator>("Transform", &DefaultGroupingCreator::createTransform);
  defineNewCreationFunction<DefaultGroupingCreator>("X3DChildNode", 0);
  defineNewCreationFunction<DefaultGroupingCreator>("X3DGroupingNode", 0);
}

DefaultGroupingCreator::~DefaultGroupingCreator()
{
}

SFNode DefaultGroupingCreator::createGroup() const
{
  return new Group();
}

SFNode DefaultGroupingCreator::createStaticGroup() const
{
  return new StaticGroup();
}

SFNode DefaultGroupingCreator::createTransform() const
{
  return new Transform();
}
