#include "DefaultRenderingCreator.h"
#include "RenderingNodes.h"

using namespace X3DTK;

DefaultRenderingCreator::DefaultRenderingCreator()
{
  defineNewCreationFunction<DefaultRenderingCreator>("Color" , &DefaultRenderingCreator::createColor);
  defineNewCreationFunction<DefaultRenderingCreator>("ColorRGBA" , &DefaultRenderingCreator::createColorRGBA);
  defineNewCreationFunction<DefaultRenderingCreator>("Coordinate" , &DefaultRenderingCreator::createCoordinate);
  defineNewCreationFunction<DefaultRenderingCreator>("IndexedLineSet" , &DefaultRenderingCreator::createIndexedLineSet);
  defineNewCreationFunction<DefaultRenderingCreator>("Normal" , &DefaultRenderingCreator::createNormal);
  defineNewCreationFunction<DefaultRenderingCreator>("PointSet" , &DefaultRenderingCreator::createPointSet);
  defineNewCreationFunction<DefaultRenderingCreator>("TriangleFanSet" , &DefaultRenderingCreator::createTriangleFanSet);
  defineNewCreationFunction<DefaultRenderingCreator>("TriangleSet" , &DefaultRenderingCreator::createTriangleSet);
  defineNewCreationFunction<DefaultRenderingCreator>("TriangleStripSet" , &DefaultRenderingCreator::createTriangleStripSet);
  defineNewCreationFunction<DefaultRenderingCreator>("X3DColorNode" , 0);
  defineNewCreationFunction<DefaultRenderingCreator>("X3DComposedGeometryNode" , 0);
  defineNewCreationFunction<DefaultRenderingCreator>("X3DCoordinateNode" , 0);
  defineNewCreationFunction<DefaultRenderingCreator>("X3DGeometricPropertyNode" , 0);
  defineNewCreationFunction<DefaultRenderingCreator>("X3DGeometry3DNode" , 0);
  defineNewCreationFunction<DefaultRenderingCreator>("X3DGeometryNode" , 0);
  defineNewCreationFunction<DefaultRenderingCreator>("X3DNormalNode" , 0);
}

DefaultRenderingCreator::~DefaultRenderingCreator()
{
}

SFNode DefaultRenderingCreator::createColor() const
{
  return new Color();
}

SFNode DefaultRenderingCreator::createColorRGBA() const
{
  return new ColorRGBA();
}

SFNode DefaultRenderingCreator::createCoordinate() const
{
  return new Coordinate();
}

SFNode DefaultRenderingCreator::createIndexedLineSet() const
{
  return new IndexedLineSet();
}

SFNode DefaultRenderingCreator::createNormal() const
{
  return new Normal();
}

SFNode DefaultRenderingCreator::createPointSet() const
{
  return new PointSet();
}

SFNode DefaultRenderingCreator::createTriangleFanSet() const
{
  return new TriangleFanSet();
}

SFNode DefaultRenderingCreator::createTriangleSet() const
{
  return new TriangleSet();
}

SFNode DefaultRenderingCreator::createTriangleStripSet() const
{
  return new TriangleStripSet();
}
