#include "DefaultTexturingCreator.h"
#include "TexturingNodes.h"

using namespace X3DTK;

DefaultTexturingCreator::DefaultTexturingCreator()
{
  defineNewCreationFunction<DefaultTexturingCreator>("ImageTexture" , &DefaultTexturingCreator::createImageTexture);
  defineNewCreationFunction<DefaultTexturingCreator>("TextureCoordinate" , &DefaultTexturingCreator::createTextureCoordinate);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTexture2DNode" , 0);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTextureCoordinateNode" , 0);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTextureNode" , 0);
  defineNewCreationFunction<DefaultTexturingCreator>("X3DTextureTransformNode" , 0);
}

DefaultTexturingCreator::~DefaultTexturingCreator()
{
}

SFNode DefaultTexturingCreator::createImageTexture() const
{
  return new ImageTexture();
}

SFNode DefaultTexturingCreator::createTextureCoordinate() const
{
  return new TextureCoordinate();
}
