#include "X3DAbstractNode.h"
#include "Type.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

X3DAbstractNode::X3DAbstractNode()
: _type(0), _scene(0)
{    
  defineTagName("X3DAbstractNode", "Root");
}

SFNode X3DAbstractNode::clone() const
{
  // Returns 0 because it is an abstract node.
  return 0;
}

X3DAbstractNode::X3DAbstractNode(const X3DAbstractNode &N)
: _type(N._type), _scene(N._scene), _parentList(N._parentList)
{
  defineTagName("X3DAbstractNode", "Root");
}

X3DAbstractNode::~X3DAbstractNode()
{
  //this method is recursive and removes one instance for all the parents of
  //the type.
  Type::removeOneReference(_type);
  /// Removes the instance for all the parents
  for (MFNode::iterator it = _parentList.begin(); it != _parentList.end(); ++it)
    (*it)->removeChild(this);
}

void X3DAbstractNode::addParent(const SFNode &N)
{
  if (N != 0)
    _parentList.push_back(N);
}

bool X3DAbstractNode::removeParent(const SFNode &N)
{
  if (N != 0)
  {
    MFNode::iterator res = find(_parentList.begin(), _parentList.end(), this);
    if (res != _parentList.end())
    {
      _parentList.erase(res);
      return true;
    }
  }
  return false;
}

void X3DAbstractNode::loadAttributes(const X3DFileElement *element)
{
}

SFString X3DAbstractNode::writeAttributes() const
{
  return "";
}

bool X3DAbstractNode::addChild(const SFNode &N)
{
  return false;
}

bool X3DAbstractNode::setChild(const SFNode &N)
{
  return false;
}

bool X3DAbstractNode::removeChild(const SFNode &N)
{
  return false;
}

void X3DAbstractNode::removeLink(SFNode father, SFNode child)
{
  if (child != 0)
    child->removeParent(father);
}

void X3DAbstractNode::addLink(SFNode father, SFNode child)
{
  if (child != 0)
    child->addParent(father);
}
