#include "DefaultGLDFSGLGroupingWalker.h"
#include "NodeWalkingProxy.h"
#include "NodeVisitingProxy.h"
#include "GLGroupingNodes.h"

using namespace X3DTK;

DefaultGLDFSGLGroupingWalker::DefaultGLDFSGLGroupingWalker()
: DFSGLGroupingWalker()
{
  defineNewWalkingFunction<DefaultGLDFSGLGroupingWalker, GLStaticGroup>(&DefaultGLDFSGLGroupingWalker::walkGLStaticGroup);
  defineNewWalkingFunction<DefaultGLDFSGLGroupingWalker, X3DGLGroupingNode>(&DefaultGLDFSGLGroupingWalker::walkX3DGLGroupingNode);
}

DefaultGLDFSGLGroupingWalker::~DefaultGLDFSGLGroupingWalker()
{
}

void DefaultGLDFSGLGroupingWalker::walkGLStaticGroup(GLStaticGroup *G) const
{
  nodeVisitingProxy->enter(G);
  
  MFNode children = G->getChildren();
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    if ((*it != 0) && (nodeVisitingProxy->walkOn(G, *it)))
      nodeWalkingProxy->walk(*it);
  
  nodeVisitingProxy->leave(G);
}

void DefaultGLDFSGLGroupingWalker::walkX3DGLGroupingNode(X3DGLGroupingNode *N) const
{
  nodeVisitingProxy->enter(N);
  
  MFNode children = N->getChildren();
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    if ((*it != 0) && (nodeVisitingProxy->walkOn(N, *it)))
      nodeWalkingProxy->walk(*it);
  
  nodeVisitingProxy->leave(N);
}
