#include "X3DTTAlgorithm.h"
#include "NodeVisitingProxy.h"
#include "NodeWalkingProxy.h"
#include "X3DNode.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

X3DTTAlgorithm::X3DTTAlgorithm()
: nvp(new NodeVisitingProxy()), nwp(new NodeWalkingProxy())
{
  nwp->setNodeVisitingProxy(nvp);
}

X3DTTAlgorithm::~X3DTTAlgorithm()
{
  delete nwp;
  delete nvp;
}

void X3DTTAlgorithm::setComponentWalker(X3DComponentWalker *component)
{
  nwp->setComponentWalker(component);
}

void X3DTTAlgorithm::setComponentVisitor(X3DComponentVisitor *component)
{
  nvp->setComponentVisitor(component);
}

void X3DTTAlgorithm::setAutoDeleteComponents(bool value)
{
  nvp->setAutoDeleteComponents(value);
  nwp->setAutoDeleteComponents(value);
}
  
void X3DTTAlgorithm::traverse(SFNode N) const
{
  if ((nwp != 0) && (N != 0))
    nwp->walk(N);
}
