#include "GLCylinder.h"
#include "Cylinder.h"
#include "CylinderDrawArray.h"

using namespace X3DTK;

GLCylinder::GLCylinder()
: X3DGLGeometry3DNode(), _radius(0.0f), _height(0.0f), _side(false), _bottom(false), _top(false), _cylinderArray(0)
{
  defineTagName("GLCylinder", "GLGeometry3D");
}

GLCylinder::GLCylinder(const GLCylinder &C)
: X3DGLGeometry3DNode(C), _radius(C._radius), _height(C._height), _side(C._side), _bottom(C._bottom), _top(C._top), _cylinderArray(0)
{
  defineTagName("GLCylinder", "GLGeometry3D");
}

SFNode GLCylinder::clone() const
{
  return new GLCylinder(*this);
}

GLCylinder::~GLCylinder()
{
  _cylinderArray->removeInstance();
}
