#include "GLStaticGroup.h"
#include "StaticGroup.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

GLStaticGroup::GLStaticGroup()
: X3DGLChildNode()
{  
  defineTagName("GLStaticGroup", "GLGrouping");
}

GLStaticGroup::GLStaticGroup(const GLStaticGroup &G)
: X3DGLChildNode(G), _children(G._children)
{
}

SFNode GLStaticGroup::clone() const
{
  return new GLStaticGroup(*this);
}

GLStaticGroup::~GLStaticGroup()
{  defineTagName("GLStaticGroup", "GLGrouping");
}

bool GLStaticGroup::addChild(const SFNode &N)
{
  if (dynamic_cast<X3DGLChildNode *>(N) != 0)
  {
    _children.push_back(N);
    return true;
  }
  
  cerr << "GLStaticGroup::addChild : a node of type " << N->getName() << " cannot be a child!" << endl;
  return false;    
}

bool GLStaticGroup::setChild(const SFNode &N)
{
  if (dynamic_cast<X3DGLChildNode *>(N) != 0)
  {
    _children.push_back(N);
    return true;
  }
  
  cerr << "GLStaticGroup::setChild : a node of type " << N->getName() << " cannot be a child!" << endl;
  return false;   
}

bool GLStaticGroup::removeChild(const SFNode &N)
{
  MFNode::iterator res = find(_children.begin(), _children.end(), N);
  if (res != _children.end())
  {
    _children.erase(res);
    return true;
  }  
  return false;
}
