#include "X3DGLGroupingNode.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

X3DGLGroupingNode::X3DGLGroupingNode()
: X3DGLChildNode()
{
  defineTagName("X3DGLGroupingNode", "GLGrouping");
}

X3DGLGroupingNode::X3DGLGroupingNode(const X3DGLGroupingNode &N)
: X3DGLChildNode(N)
{
  defineTagName("X3DGLGroupingNode", "GLGrouping");
}

SFNode X3DGLGroupingNode::clone() const
{
  return 0;
}

X3DGLGroupingNode::~X3DGLGroupingNode()
{
}

bool X3DGLGroupingNode::addChild(const SFNode &N)
{
  if (dynamic_cast<X3DGLChildNode *>(N) != 0)
  {
    _children.push_back(N);
    return true;
  }
  
  cerr << "X3DGLGroupingNode::addChild : a node of type " << N->getName() << " cannot be a child!" << endl;
  return false;    
}

bool X3DGLGroupingNode::setChild(const SFNode &N)
{
  if (dynamic_cast<X3DGLChildNode *>(N) != 0)
  {
    _children.push_back(N);
    return true;
  }
  
  cerr << "X3DGLGroupingNode::setChild : a node of type " << N->getName() << " cannot be a child!" << endl;
  return false;   
}

bool X3DGLGroupingNode::removeChild(const SFNode &N)
{
  MFNode::iterator res = find(_children.begin(), _children.end(), N);
  if (res != _children.end())
  {
    _children.erase(res);
    return true;
  }  
  return false;
}
