#include "GLMaterial.h"
#include "Material.h"

using namespace X3DTK;
using namespace std;

GLMaterial::GLMaterial()
: X3DGLMaterialNode(), _diffuseColor(MFFloat(4)), _ambientColor(MFFloat(4)), _emissiveColor(MFFloat(4)), _shininess(0.0f), _specularColor(MFFloat(4))
{
  defineTagName("GLMaterial", "GLShape");
}

GLMaterial::GLMaterial(const GLMaterial &M)
: X3DGLMaterialNode(M), _diffuseColor(M._diffuseColor), _ambientColor(M._ambientColor), _emissiveColor(M._emissiveColor), _shininess(M._shininess), _specularColor(M._specularColor)
{
  defineTagName("GLMaterial", "GLShape");
}

SFNode GLMaterial::clone() const
{
  return new GLMaterial(*this);
}

GLMaterial::~GLMaterial()
{
}
