#include "GLImageTexture.h"
#include "ImageTexture.h"

using namespace X3DTK;

GLImageTexture::GLImageTexture()
: X3DGLTexture2DNode(), _texName(0), _textureTransform(16)
{
  defineTagName("GLImageTexture", "GLTexturing");
  
  _textureTransform[0] = 1.0f;
  _textureTransform[1] = 0.0f;
  _textureTransform[2] = 0.0f;
  _textureTransform[3] = 0.0f;
  
  _textureTransform[4] = 0.0f;
  _textureTransform[5] = 1.0f;
  _textureTransform[6] = 0.0f;
  _textureTransform[7] = 0.0f;

  _textureTransform[8] = 0.0f;
  _textureTransform[9] = 0.0f;
  _textureTransform[10] = 1.0f;
  _textureTransform[11] = 0.0f;

  _textureTransform[12] = 0.0f;
  _textureTransform[13] = 0.0f;
  _textureTransform[14] = 0.0f;
  _textureTransform[15] = 1.0f;
}

GLImageTexture::GLImageTexture(const GLImageTexture &I)
: X3DGLTexture2DNode(I), _texName(I._texName), _textureTransform(I._textureTransform)
{
  defineTagName("GLImageTexture", "GLTexturing");
}

SFNode GLImageTexture::clone() const
{
  return new GLImageTexture(*this);
}

GLImageTexture::~GLImageTexture()
{
  glDeleteTextures(1, &_texName);
}
