#include "X3DBoundedObject.h"

using namespace X3DTK;

X3DBoundedObject::X3DBoundedObject()
: X3DObject(), bboxCenter_(SFVec3f(0.0f, 0.0f, 0.0f)), bboxSize_(SFVec3f(-1.0f, -1.0f, -1.0f))
{
}

X3DBoundedObject::X3DBoundedObject(const SFVec3f &bboxCenter, const SFVec3f &bboxSize)
: X3DObject(), bboxCenter_(bboxCenter), bboxSize_(bboxSize)
{
}

X3DBoundedObject::X3DBoundedObject(const X3DBoundedObject &N)
: X3DObject(N), bboxCenter_(N.bboxCenter_), bboxSize_(N.bboxSize_)
{
}

X3DBoundedObject::~X3DBoundedObject()
{
}

void X3DBoundedObject::setBboxCenter(const SFVec3f &bboxCenter)
{
  bboxCenter_ = bboxCenter;
}

void X3DBoundedObject::setBboxSize(const SFVec3f &bboxSize)
{
  bboxSize_ = bboxSize;
}

void X3DBoundedObject::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("bboxCenter");
  if (index != -1)
    bboxCenter_ = SFVec3f(element->getAttribute(index));

  index = element->getIndexAttribute("bboxSize");
  if (index != -1)
    bboxSize_ = SFVec3f(element->getAttribute(index)); 
}

SFString X3DBoundedObject::writeAttributes() const
{
  SFString attr;
  if (bboxCenter_ != SFVec3f(0.0f, 0.0f, 0.0f))
    attr += " bboxCenter=\"" + toSFString(bboxCenter_) + "\"";
  if (bboxSize_ != SFVec3f(-1.0f, -1.0f, -1.0f))  
    attr += " bboxSize=\"" + toSFString(bboxSize_) + "\"";
    
  return attr;  
}
