#include "X3DGroupingNode.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

X3DGroupingNode::X3DGroupingNode()
: X3DChildNode()
{
  defineTagName("X3DGroupingNode", "Grouping");
}

X3DGroupingNode::X3DGroupingNode(const X3DGroupingNode &N)
: X3DChildNode(N), children_(N.children_)
{
  defineTagName("X3DGroupingNode", "Grouping");
}

SFNode X3DGroupingNode::clone() const
{
  return 0;
}

X3DGroupingNode::~X3DGroupingNode()
{
}

bool X3DGroupingNode::addChild(const SFNode &N)
{
  if (dynamic_cast<X3DChildNode *>(N) != 0)
  {
    children_.push_back(N);
    addLink(this, N);
    return true;
  }
  
  cerr << "X3DGroupingNode::addChild : a node of type " << N->getName() << " cannot be a child!" << endl;
  return false;    
}

bool X3DGroupingNode::setChild(const SFNode &N)
{
  if (dynamic_cast<X3DChildNode *>(N) != 0)
  {
    children_.push_back(N);
    addLink(this, N);
    return true;
  }
  
  cerr << "X3DGroupingNode::setChild : a node of type " << N->getName() << " cannot be a child!" << endl;
  return false;    
}

bool X3DGroupingNode::removeChild(const SFNode &N)
{
  MFNode::iterator res = find(children_.begin(), children_.end(), N);
  if (res != children_.end())
  {
    children_.erase(res);
    removeLink(this, N);
    return true;
  }  
    
  return false;
}
