#include "Color.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

Color::Color()
: X3DColorNode()
{
  defineTagName("Color", "Rendering");
}

Color::Color(const MFColor &color)
: X3DColorNode(), color_(color)
{
  defineTagName("Color", "Rendering");
}

Color::Color(const Color &C)
: X3DColorNode(), color_(C.color_)
{
  defineTagName("Color", "Rendering");
}

SFNode Color::clone() const
{
  return new Color(*this);
}

Color::~Color()
{
}

void Color::setColor(const MFColor &color)
{
  color_ = color;
}

void Color::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("color");
  if (index != -1)
    color_ = MFColor(element->getAttribute(index));
}

SFString Color::writeAttributes() const
{
  SFString attr;
  if (!color_.empty())
    attr += " color=\"" + toSFString(color_) + "\"";
      
  return attr;
}
