#include "ColorRGBA.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

ColorRGBA::ColorRGBA()
: X3DColorNode()
{
  defineTagName("ColorRGBA", "Rendering");
}

ColorRGBA::ColorRGBA(const MFColorRGBA &color)
: X3DColorNode(), color_(color)
{
  defineTagName("ColorRGBA", "Rendering");
}

SFNode ColorRGBA::clone() const
{
  return new ColorRGBA(*this);
}

ColorRGBA::~ColorRGBA()
{
}

ColorRGBA::ColorRGBA(const ColorRGBA &C)
: X3DColorNode(), color_(C.color_)
{
  defineTagName("ColorRGBA", "Rendering");
}

void ColorRGBA::setColor(const MFColorRGBA &color)
{
  color_ = color;
}

void ColorRGBA::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("color");
  if (index != -1)
    color_ = MFColorRGBA(element->getAttribute(index));
}

SFString ColorRGBA::writeAttributes() const
{
  SFString attr;
  if (!color_.empty())
    attr += " color=\"" + toSFString(color_) + "\"";
    
  return attr;
}
