#include "Coordinate.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

Coordinate::Coordinate()
: X3DCoordinateNode()
{
  defineTagName("Coordinate", "Rendering");
}

Coordinate::Coordinate(const MFVec3f &point)
: X3DCoordinateNode(), point_(point)
{
  defineTagName("Coordinate", "Rendering");
}

Coordinate::Coordinate(const Coordinate &C)
: X3DCoordinateNode(), point_(C.point_)
{
  defineTagName("Coordinate", "Rendering");
}

SFNode Coordinate::clone() const
{
  return new Coordinate(*this);
}

Coordinate::~Coordinate()
{
}

void Coordinate::setPoint(const MFVec3f &point)
{
  point_ = point;
}

void Coordinate::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("point");
  if (index != -1)
    point_ = MFVec3f(element->getAttribute(index));
}

SFString Coordinate::writeAttributes() const
{
  SFString attr;
  if (!point_.empty())
    attr += " point=\"" + toSFString(point_) + "\"";
    
  return attr;
}
