#include "Normal.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

Normal::Normal()
: X3DNormalNode()
{
  defineTagName("Normal", "Rendering");
}

Normal::Normal(const MFVec3f &vector)
: X3DNormalNode(), vector_(vector)
{
  defineTagName("Normal", "Rendering");
}

Normal::Normal(const Normal &C)
: X3DNormalNode(), vector_(C.vector_)
{
  defineTagName("Normal", "Rendering");
}

SFNode Normal::clone() const
{
  return new Normal(*this);
}

Normal::~Normal()
{
}

void Normal::setVector(const MFVec3f &vector)
{
  vector_ = vector;
}

void Normal::loadAttributes(const X3DFileElement *element)
{ 
  int index;
  index = element->getIndexAttribute("vector");
  if (index != -1)
    vector_ = MFVec3f(element->getAttribute(index));  
}

SFString Normal::writeAttributes() const
{
  SFString attr;
  if (!vector_.empty())
    attr += " vector=\"" + toSFString(vector_) + "\"";
      
  return attr;
}
