#include "ImageTexture.h"

using namespace X3DTK;

ImageTexture::ImageTexture()
: X3DTexture2DNode()
{
  defineTagName("ImageTexture", "Texturing");
}

ImageTexture::ImageTexture(const ImageTexture &N)
: X3DTexture2DNode(N)
{
  defineTagName("ImageTexture", "Texturing");
}

SFNode ImageTexture::clone() const
{
  return new ImageTexture(*this);
}

ImageTexture::~ImageTexture()
{
}
  
void ImageTexture::setUrl(const MFString &url)
{
  url_ = url;
}

void ImageTexture::loadAttributes(const X3DFileElement *element)
{
  X3DTexture2DNode::loadAttributes(element);

  int index;
  index = element->getIndexAttribute("url");
  if (index != -1)
    url_ = MFString(element->getAttribute(index));
}

SFString ImageTexture::writeAttributes() const
{
  SFString attr;
  attr += X3DTexture2DNode::writeAttributes();
  
  if (!url_.empty())
    attr += " url=\'" + toSFString(url_) + "\'";
        
  return attr;
}
