#include "X3DTexture2DNode.h"

using namespace X3DTK;

X3DTexture2DNode::X3DTexture2DNode()
: X3DTextureNode(), repeatS_(true), repeatT_(true)
{
  defineTagName("X3DTexture2DNode", "Texturing");
}

X3DTexture2DNode::X3DTexture2DNode(const X3DTexture2DNode &N)
: X3DTextureNode(N), repeatS_(N.repeatS_), repeatT_(N.repeatT_)
{
  defineTagName("X3DTexture2DNode", "Texturing");
}

SFNode X3DTexture2DNode::clone() const
{
  return 0;
}

X3DTexture2DNode::~X3DTexture2DNode()
{
}

void X3DTexture2DNode::setRepeatS(SFBool repeatS)
{
  repeatS_ = repeatS;
}

void X3DTexture2DNode::setRepeatT(SFBool repeatT)
{
  repeatT_ = repeatT;
}

void X3DTexture2DNode::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("repeatS");
  if (index != -1)
    repeatS_ = (element->getAttribute(index).upper() == "TRUE");  
  
  index = element->getIndexAttribute("repeatT");
  if (index != -1)
    repeatT_ = (element->getAttribute(index).upper() == "TRUE");    
}

SFString X3DTexture2DNode::writeAttributes() const
{
  SFString attr;
  if (!repeatS_)
    attr += " repeatS=\"FALSE\"";
  if (!repeatT_)
    attr += " repeatT=\"FALSE\"";
    
  return attr;
}
