#include "X3DTextureCoordinateNode.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

X3DTextureCoordinateNode::X3DTextureCoordinateNode()
: X3DGeometricPropertyNode()
{
  defineTagName("X3DTextureCoordinateNode", "Texturing");
}

X3DTextureCoordinateNode::X3DTextureCoordinateNode(const MFVec2f &point)
: X3DGeometricPropertyNode(), point(point)
{
  defineTagName("X3DTextureCoordinateNode", "Texturing");
}

X3DTextureCoordinateNode::X3DTextureCoordinateNode(const X3DTextureCoordinateNode &N)
: X3DGeometricPropertyNode(N), point(N.point)
{
  defineTagName("X3DTextureCoordinateNode", "Texturing");
}

SFNode X3DTextureCoordinateNode::clone() const
{
  return 0;
}

X3DTextureCoordinateNode::~X3DTextureCoordinateNode()
{
}

void X3DTextureCoordinateNode::setPoint(const MFVec2f &point)
{
  this->point = point;
}

void X3DTextureCoordinateNode::loadAttributes(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("point");
  if (index != -1)
    point = MFVec2f(element->getAttribute(index));
}

SFString X3DTextureCoordinateNode::writeAttributes() const
{
  SFString attr;
  if (!point.empty())
    attr += " point=\"" + toSFString(point) + "\"";
  
  return attr;
}
