#include "Bbox.h"

using namespace X3DTK;

Bbox::Bbox()
{
  center_ = SFVec3f(0.0f, 0.0f, 0.0f);
  size_ = SFVec3f(-1.0f, -1.0f, -1.0f);
}

Bbox::Bbox(const SFVec3f &center, const SFVec3f &size)
{
  center_ = center;
  size_ = size;
}

Bbox::Bbox(const MFVec3f &coord)
{
  if (coord.empty())
  {
    Bbox BB(SFVec3f(0.0f, 0.0f, 0.0f), SFVec3f(0.0f, 0.0f, 0.0f));
    return;
  }
  
  SFVec3f min = coord[0];
  SFVec3f max = coord[0];
  
  for (MFVec3f::const_iterator itVertex = coord.begin(); itVertex != coord.end(); ++itVertex)
  {
    SFVec3f min2 = *itVertex;
    SFVec3f max2 = *itVertex;
  
    if (min2.x < min.x)
      min.x = min2.x;
    if (min2.y < min.y)
      min.y = min2.y;
    if (min2.z < min.z)
      min.z = min2.z;
  
    if (max2.x < max.x)
      max.x = max2.x;
    if (max2.y < max.y)
      max.y = max2.y;
    if (max2.z < max.z)
      max.z = max2.z;
  }
  
  //computing the new center
  center_ = 0.5f*(min + max);
  size_ = 2.0f*(max - center_);
}

Bbox::Bbox(const Bbox &B)
{
  center_ = B.center_;
  size_ = B.size_;
}

