#include "SFString.h"

#include <iostream>
#include <sstream>

using namespace X3DTK;
using namespace std;

SFString::SFString()
: string()
{
}

SFString::SFString(const char *s)
: string(s)
{
}

SFString::SFString(const std::string &s)
: string(s)
{
}

SFString::SFString(const SFString &s)
: string(s)
{
}

SFString::operator const char *() const
{
  //return this->c_str();
  return this->data();
}

int SFString::toInt() const
{
  istringstream iss(*this, istringstream::in);
  int r;
  iss >> r;
  return r;
}
  
unsigned int SFString::toUint() const
{
  istringstream iss(*this, istringstream::in);
  unsigned int r;
  iss >> r;
  return r;
}

float SFString::toFloat() const
{
  istringstream iss(*this, istringstream::in);
  float r;
  iss >> r;
  return r;
}

double SFString::toDouble() const
{
  istringstream iss(*this, istringstream::in);
  double r;
  iss >> r;
  return r;
}

SFString SFString::lower() const
{
  SFString res(*this);
  for (SFString::iterator it  = res.begin(); it != res.end(); ++it)
    if (((*it) > 64) && ((*it) < 91))
      *it = *it + 32;

  return res;
}

SFString SFString::upper() const
{
  SFString res(*this);
  for (SFString::iterator it  = res.begin(); it != res.end(); ++it)
  {
    if (((*it) > 96) && ((*it) < 123))
      *it = *it - 32;
  }    

  return res;
}

SFString SFString::getPath() const
{
  return this->substr(0, this->find_last_of('/'));
}

SFString SFString::number(float f)
{
  ostringstream oss;
  oss << f;
  return  oss.str();
}

SFString SFString::number(double d)
{
  ostringstream oss;
  oss << d;
  return  oss.str();
}

SFString SFString::number(int i)
{
  ostringstream oss;
  oss << i;
  return oss.str();

}

SFString SFString::number(unsigned int ui)
{
  ostringstream oss;
  oss << ui;
  return  oss.str();
}
