#include "BboxUpdaterCoreVisitor.h"
#include "X3DNode.h"
#include "Scene.h"
#include "Bbox.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

BboxUpdaterCoreVisitor::BboxUpdaterCoreVisitor()
: CoreVisitor()
{
  // WalkOn functions.
  defineNewWalkOnFunction<BboxUpdaterCoreVisitor, X3DNode>(&BboxUpdaterCoreVisitor::walkOnX3DNode);

  // Leave functions.
  defineNewLeaveFunction<BboxUpdaterCoreVisitor, Scene>(&BboxUpdaterCoreVisitor::leaveScene);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<BboxUpdaterGlobalVariables>();
}

BboxUpdaterCoreVisitor::~BboxUpdaterCoreVisitor()
{
}

bool BboxUpdaterCoreVisitor::walkOnX3DNode(X3DNode *N, SFNode Child) const
{
  return false;
}

void BboxUpdaterCoreVisitor::leaveScene(Scene *S) const
{
  Bbox *BB = globalVariables->getBbox(S);
  if (BB == 0)
  {
    MFNode children = S->getChildren();
    for (MFNode::const_iterator it = children.begin(); it != children.end(); ++it)
    {
      X3DBoundedObject *O = dynamic_cast<X3DBoundedObject *>(*it);
      if (O != 0)
        globalVariables->addBboxToMergeList(Bbox(O->getBboxCenter(), O->getBboxSize()));
    }
    BB = new Bbox(globalVariables->mergeBbox()); 
    globalVariables->addBbox(S, BB);
    
    //updating the Bbox attributes.
    S->setBboxCenter(BB->getCenter());
    S->setBboxSize(BB->getSize());
    
    //cout << "Scene contained in the Bounding Box:" << endl;
    //cout << "  center: " << BB->getCenter() << endl;
    //cout << "  size: " << BB->getSize() << endl;
  }
}
