#include "GLCreatorGeometry3DVisitor.h"
#include "Box.h"
#include "Cone.h"
#include "Cylinder.h"
#include "IndexedFaceSet.h"
#include "Sphere.h"
#include "GLBox.h"
#include "GLCone.h"
#include "GLCylinder.h"
#include "GLIndexedFaceSet.h"
#include "GLSphere.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

GLCreatorGeometry3DVisitor::GLCreatorGeometry3DVisitor()
: Geometry3DVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLCreatorGeometry3DVisitor, Box>(&GLCreatorGeometry3DVisitor::enterBox);
  defineNewEnterFunction<GLCreatorGeometry3DVisitor, Cone>(&GLCreatorGeometry3DVisitor::enterCone);
  defineNewEnterFunction<GLCreatorGeometry3DVisitor, Cylinder>(&GLCreatorGeometry3DVisitor::enterCylinder);
  defineNewEnterFunction<GLCreatorGeometry3DVisitor, IndexedFaceSet>(&GLCreatorGeometry3DVisitor::enterIndexedFaceSet);
  defineNewEnterFunction<GLCreatorGeometry3DVisitor, Sphere>(&GLCreatorGeometry3DVisitor::enterSphere);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLCreatorGlobalVariables>();
}

GLCreatorGeometry3DVisitor::~GLCreatorGeometry3DVisitor()
{
}

void GLCreatorGeometry3DVisitor::enterBox(Box *B) const
{
  GLBox *GB = new GLBox();
  GB->setLink(B);
  globalVariables->getTop()->addChild(GB);
  globalVariables->pushNode(GB);
}

void GLCreatorGeometry3DVisitor::enterCone(Cone *C) const
{
  GLCone *GC = new GLCone();
  GC->setLink(C);
  globalVariables->getTop()->addChild(GC);
  globalVariables->pushNode(GC);
}

void GLCreatorGeometry3DVisitor::enterCylinder(Cylinder *C) const
{
  GLCylinder *GC = new GLCylinder();
  GC->setLink(C);
  globalVariables->getTop()->addChild(GC);
  globalVariables->pushNode(GC);
}

void GLCreatorGeometry3DVisitor::enterIndexedFaceSet(IndexedFaceSet *I) const
{
  GLIndexedFaceSet *GI = new GLIndexedFaceSet();
  GI->setLink(I);
  globalVariables->getTop()->addChild(GI);
  globalVariables->pushNode(GI);
}

void GLCreatorGeometry3DVisitor::enterSphere(Sphere *S) const
{
  GLSphere *GS = new GLSphere();
  GS->setLink(S);
  globalVariables->getTop()->addChild(GS);
  globalVariables->pushNode(GS);
}
