#include "GLCreatorRenderingVisitor.h"
#include "IndexedLineSet.h"
#include "PointSet.h"
#include "TriangleFanSet.h"
#include "TriangleSet.h"
#include "TriangleStripSet.h"
#include "GLIndexedLineSet.h"
#include "GLPointSet.h"
#include "GLTriangleFanSet.h"
#include "GLTriangleSet.h"
#include "GLTriangleStripSet.h"
#include "X3DGeometryNode.h"

using namespace X3DTK;

GLCreatorRenderingVisitor::GLCreatorRenderingVisitor()
: RenderingVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLCreatorRenderingVisitor, IndexedLineSet>(&GLCreatorRenderingVisitor::enterIndexedLineSet);
  defineNewEnterFunction<GLCreatorRenderingVisitor, PointSet>(&GLCreatorRenderingVisitor::enterPointSet);
  defineNewEnterFunction<GLCreatorRenderingVisitor, TriangleFanSet>(&GLCreatorRenderingVisitor::enterTriangleFanSet);
  defineNewEnterFunction<GLCreatorRenderingVisitor, TriangleSet>(&GLCreatorRenderingVisitor::enterTriangleSet);
  defineNewEnterFunction<GLCreatorRenderingVisitor, TriangleStripSet>(&GLCreatorRenderingVisitor::enterTriangleStripSet);

  // WalkOn functions
  defineNewWalkOnFunction<GLCreatorRenderingVisitor, X3DGeometryNode>(&GLCreatorRenderingVisitor::walkOnX3DGeometryNode);

  
  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLCreatorGlobalVariables>();
}

GLCreatorRenderingVisitor::~GLCreatorRenderingVisitor()
{
}

void GLCreatorRenderingVisitor::enterIndexedLineSet(IndexedLineSet *I) const
{
  GLIndexedLineSet *GI = new GLIndexedLineSet();
  GI->setLink(I);
  globalVariables->getTop()->addChild(GI);
  globalVariables->pushNode(GI);
}

void GLCreatorRenderingVisitor::enterPointSet(PointSet *P) const
{
  GLPointSet *GP = new GLPointSet();
  GP->setLink(P);
  globalVariables->getTop()->addChild(GP);
  globalVariables->pushNode(GP);
}

void GLCreatorRenderingVisitor::enterTriangleFanSet(TriangleFanSet *T) const
{
  GLTriangleFanSet *GT = new GLTriangleFanSet();
  GT->setLink(T);
  globalVariables->getTop()->addChild(GT);
  globalVariables->pushNode(GT);
}

void GLCreatorRenderingVisitor::enterTriangleSet(TriangleSet *T) const
{
  GLTriangleSet *GT = new GLTriangleSet();
  GT->setLink(T);
  globalVariables->getTop()->addChild(GT);
  globalVariables->pushNode(GT);
}

void GLCreatorRenderingVisitor::enterTriangleStripSet(TriangleStripSet *T) const
{
  GLTriangleStripSet *GT = new GLTriangleStripSet();
  GT->setLink(T);
  globalVariables->getTop()->addChild(GT);
  globalVariables->pushNode(GT);
}

bool GLCreatorRenderingVisitor::walkOnX3DGeometryNode(X3DGeometryNode *N, SFNode child) const
{
  return false;
}
