/// This file is part of the QGLViewer library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
/// selon les termes de la Licence Publique Gnrale GNU publie par la Free
/// Software Foundation (version 2 ou bien toute autre version ultrieure
/// choisie par vous).

/// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
/// GARANTIE, ni explicite ni implicite, y compris les garanties de
/// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous
///  la Licence Publique Gnrale GNU pour plus de dtails.

/// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
/// mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
/// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
/// 02111-1307, tats-Unis. 

////////////////////////////////////////////////////////////////////////////////
//                            GLCreatorRenderingVisitor.h                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLCREATORRENDERINGVISITOR_H
#define GLCREATORRENDERINGVISITOR_H

#include "RenderingVisitor.h"
#include "GLCreatorGlobalVariables.h"

namespace X3DTK {

class IndexedLineSet;
class PointSet;
class TriangleFanSet;
class TriangleSet;
class TriangleStripSet;
class X3DGeometryNode;

/// Visitor for the Rendering component of the GLCreator module.

class GLCreatorRenderingVisitor : public RenderingVisitor
{
public:
  /// Constructor.
  GLCreatorRenderingVisitor();
  /// Destructor.
  virtual ~GLCreatorRenderingVisitor();

  /// Enters a IndexedLineSet.
  virtual void enterIndexedLineSet(IndexedLineSet *I) const;
  /// Enters a PointSet.
  virtual void enterPointSet(PointSet *P) const;
  /// Enters a TriangleFanSet.
  virtual void enterTriangleFanSet(TriangleFanSet *T) const;
  /// Enters a TriangleSet.
  virtual void enterTriangleSet(TriangleSet *T) const;
  /// Enters a TriangleStripSet.
  virtual void enterTriangleStripSet(TriangleStripSet *T) const;
  
  /// Walks on an X3DGeometryNode.
  virtual bool walkOnX3DGeometryNode(X3DGeometryNode *N, SFNode child) const;
  
  

protected:
  GLCreatorGlobalVariables *globalVariables;
};

}

#endif
