#include "GLBbox.h"

#include <GL/gl.h>
#include <iostream>

using namespace std;
using namespace X3DTK;

BboxDrawArray GLBbox::bbox_array = BboxDrawArray();

GLBbox::GLBbox()
: Bbox()
{
}

GLBbox::GLBbox(const Bbox &BB)
: Bbox(BB)
{
}

GLBbox::GLBbox(const SFVec3f &min, const SFVec3f &max)
: Bbox(0.5f*(min + max), max - min)
{
}

void GLBbox::draw() const
{
  SFVec3f center = getCenter();
  SFVec3f size = getSize();
  
  glPushAttrib(GL_ALL_ATTRIB_BITS);
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_COLOR_MATERIAL);
  glDisable(GL_LIGHTING);
  glColor3f(1.0f, 1.0f, 1.0f);
  glPushMatrix();
  
  glTranslatef(center.x, center.y, center.z);
  glScalef(0.5f*size.x, 0.5f*size.y, 0.5f*size.z); 
  
  glInterleavedArrays(GL_V3F, 0, bbox_array.getBboxVertexArrayAddress());
  glDrawElements(GL_LINES, bbox_array.getBboxSize(), GL_UNSIGNED_INT,  bbox_array.getBboxIndexArrayAddress());

  glPopMatrix();
  glPopAttrib();
}
