#include "GLRenderer.h"
#include "DefaultGLDFS.h"
#include "GLRendererGLCoreVisitor.h"
#include "GLRendererGLGeometry3DVisitor.h"
#include "GLRendererGLGroupingVisitor.h"
#include "GLRendererGLRenderingVisitor.h"
#include "GLRendererGLShapeVisitor.h"
#include "GLRendererGLTexturingVisitor.h"
#include "GLScene.h"

#include <iostream>

using namespace std;
using namespace X3DTK;

GLRenderer::GLRenderer()
: X3DGLRenderer()
{
  globalVariables = GVManager::getInstanceOf<GLRendererGlobalVariables>();
  dfs = new DefaultGLDFS();
  
  dfs->setComponentVisitor(new GLRendererGLCoreVisitor());
  dfs->setComponentVisitor(new GLRendererGLGeometry3DVisitor());
  dfs->setComponentVisitor(new GLRendererGLGroupingVisitor());
  dfs->setComponentVisitor(new GLRendererGLRenderingVisitor());
  dfs->setComponentVisitor(new GLRendererGLShapeVisitor());
  dfs->setComponentVisitor(new GLRendererGLTexturingVisitor());
}

GLRenderer::~GLRenderer()
{
  delete dfs;
}

void GLRenderer::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
} 

void GLRenderer::render(GLScene *S) const
{
  dfs->traverse(S);
}
