#include "GLRendererGLGroupingVisitor.h"
#include "GLGroup.h"
#include "GLStaticGroup.h"
#include "GLTransform.h"

using namespace X3DTK;

GLRendererGLGroupingVisitor::GLRendererGLGroupingVisitor()
: GLGroupingVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLRendererGLGroupingVisitor, GLGroup>(&GLRendererGLGroupingVisitor::enterGLGroup);
  defineNewEnterFunction<GLRendererGLGroupingVisitor, GLStaticGroup>(&GLRendererGLGroupingVisitor::enterGLStaticGroup);
  defineNewEnterFunction<GLRendererGLGroupingVisitor, GLTransform>(&GLRendererGLGroupingVisitor::enterGLTransform);

  // Leave functions
  defineNewLeaveFunction<GLRendererGLGroupingVisitor, GLTransform>(&GLRendererGLGroupingVisitor::leaveGLTransform);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLRendererGlobalVariables>();
}

GLRendererGLGroupingVisitor::~GLRendererGLGroupingVisitor()
{
}

void GLRendererGLGroupingVisitor::enterGLGroup(GLGroup *G) const
{
}

void GLRendererGLGroupingVisitor::enterGLStaticGroup(GLStaticGroup *G) const
{
}

void GLRendererGLGroupingVisitor::enterGLTransform(GLTransform *G) const
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(&G->getTransformMatrix().front());
}

void GLRendererGLGroupingVisitor::leaveGLTransform(GLTransform *G) const
{
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
}
