#include "GLRendererGLShapeVisitor.h"
#include "GLAppearance.h"
#include "GLFillProperties.h"
#include "GLLineProperties.h"
#include "GLMaterial.h"
#include "GLShape.h"

using namespace X3DTK;

GLRendererGLShapeVisitor::GLRendererGLShapeVisitor()
: GLShapeVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLRendererGLShapeVisitor, GLAppearance>(&GLRendererGLShapeVisitor::enterGLAppearance);
  defineNewEnterFunction<GLRendererGLShapeVisitor, GLFillProperties>(&GLRendererGLShapeVisitor::enterGLFillProperties);
  defineNewEnterFunction<GLRendererGLShapeVisitor, GLLineProperties>(&GLRendererGLShapeVisitor::enterGLLineProperties);
  defineNewEnterFunction<GLRendererGLShapeVisitor, GLMaterial>(&GLRendererGLShapeVisitor::enterGLMaterial);
  defineNewEnterFunction<GLRendererGLShapeVisitor, GLShape>(&GLRendererGLShapeVisitor::enterGLShape);


  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLRendererGlobalVariables>();
}

GLRendererGLShapeVisitor::~GLRendererGLShapeVisitor()
{
}

void GLRendererGLShapeVisitor::enterGLAppearance(GLAppearance *G) const
{
}

void GLRendererGLShapeVisitor::enterGLFillProperties(GLFillProperties *G) const
{
}

void GLRendererGLShapeVisitor::enterGLLineProperties(GLLineProperties *G) const
{
}

void GLRendererGLShapeVisitor::enterGLMaterial(GLMaterial *G) const
{
  glMaterialfv(GL_FRONT, GL_DIFFUSE, &G->getDiffuseColor().front());
  glMaterialfv(GL_FRONT, GL_AMBIENT, &G->getAmbientColor().front());
  glMaterialfv(GL_FRONT, GL_EMISSION, &G->getEmissiveColor().front());
  glMaterialfv(GL_FRONT, GL_SHININESS, &G->getShininess()); 
  glMaterialfv(GL_FRONT, GL_SPECULAR, &G->getSpecularColor().front());
}

void GLRendererGLShapeVisitor::enterGLShape(GLShape *G) const
{
}

