/// This file is part of the QGLViewer library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
/// selon les termes de la Licence Publique Gnrale GNU publie par la Free
/// Software Foundation (version 2 ou bien toute autre version ultrieure
/// choisie par vous).

/// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
/// GARANTIE, ni explicite ni implicite, y compris les garanties de
/// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous
///  la Licence Publique Gnrale GNU pour plus de dtails.

/// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
/// mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
/// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
/// 02111-1307, tats-Unis. 

////////////////////////////////////////////////////////////////////////////////
//                            GLUpdaterGLGeometry3DVisitor.h                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLUPDATERGLGEOMETRY3DVISITOR_H
#define GLUPDATERGLGEOMETRY3DVISITOR_H

#include "GLGeometry3DVisitor.h"
#include "GLUpdaterGlobalVariables.h"

namespace X3DTK {

class GLBox;
class GLCone;
class GLCylinder;
class GLIndexedFaceSet;
class GLSphere;

/// Visitor for the GLGeometry3D component of the GLUpdater module.

class GLUpdaterGLGeometry3DVisitor : public GLGeometry3DVisitor
{
public:
  /// Constructor.
  GLUpdaterGLGeometry3DVisitor();
  /// Destructor.
  virtual ~GLUpdaterGLGeometry3DVisitor();

  /// Enters a GLBox.
  virtual void enterGLBox(GLBox *G) const;
  /// Enters a GLCone.
  virtual void enterGLCone(GLCone *G) const;
  /// Enters a GLCylinder.
  virtual void enterGLCylinder(GLCylinder *G) const;
  /// Enters a GLIndexedFaceSet.
  virtual void enterGLIndexedFaceSet(GLIndexedFaceSet *G) const;
  /// Enters a GLSphere.
  virtual void enterGLSphere(GLSphere *G) const;



protected:
  GLUpdaterGlobalVariables *globalVariables;
  
  void computeNoColor_NoTexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeColor_NoTexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeNoColor_TexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeColor_TexCoord(GLIndexedFaceSet *G, const MFVec3f &vertexArray, const MFVec3f &normalArray, const MFInt32 &coordIndex) const;
  void computeArrays(GLIndexedFaceSet *G, MFVec3f &vertexArray, MFVec3f &normalArray, MFInt32 &coordIndex) const;
};

}

#endif
