#include "MemReleaser.h"
#include "DefaultDFS.h"
#include "DefaultGLDFS.h"
#include "MemReleaserRootVisitor.h"

#include <iostream>

using namespace std;
using namespace X3DTK;

MemReleaser::MemReleaser(DFS *dfs)
: X3DMemReleaser()
{
  globalVariables = GVManager::getInstanceOf<MemReleaserGlobalVariables>();
  if (dfs == 0)
  {
    this->dfs = mergeDFS(new DefaultDFS(), new DefaultGLDFS());
    defaultDFSUSE = true;
  }  
  else
  {
    this->dfs = dfs;
    defaultDFSUSE = false;
  }
  
  //cout << "dfs = " << (void *)dfs << endl;
  
  X3DComponentVisitor *mrv = new MemReleaserRootVisitor();
  
  this->dfs->setComponentVisitor(mrv);
}

MemReleaser::~MemReleaser()
{
  if (defaultDFSUSE)
    delete dfs;
}

void MemReleaser::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
}
  
void MemReleaser::release(SFNode N) const
{
  dfs->traverse(N);
}
