#include "SceneToFileCoreVisitor.h"
#include "Scene.h"
#include "X3DNode.h"
#include "X3DTypesToSFString.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

SceneToFileCoreVisitor::SceneToFileCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  defineNewEnterFunction<SceneToFileCoreVisitor, X3DNode>(&SceneToFileCoreVisitor::enterX3DNode);
  // Walk on functions.
  defineNewWalkOnFunction<SceneToFileCoreVisitor, X3DNode>(&SceneToFileCoreVisitor::walkOnX3DNode);

  // Leave functions.
  defineNewLeaveFunction<SceneToFileCoreVisitor, X3DNode>(&SceneToFileCoreVisitor::leaveX3DNode);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<SceneToFileGlobalVariables>();
}

SceneToFileCoreVisitor::~SceneToFileCoreVisitor()
{
}

void SceneToFileCoreVisitor::enterX3DNode(X3DNode *N) const
{
  SFString attr;
  SFString USE = globalVariables->getUSE(N);

  globalVariables->newLine();
  globalVariables->pushCurrentLine();  
  
  if (USE != "")
  {
    attr += USE;
    globalVariables->pushHasUSE(true);
    globalVariables->writeCurrentLine("<" + N->getName() + attr);
  }
  else
  {
    attr += globalVariables->getDEF(N);
    globalVariables->pushHasUSE(false);    
    globalVariables->writeCurrentLine("<" + N->getName() + attr + N->writeAttributes());    
  } 

  globalVariables->addTab();
}

bool SceneToFileCoreVisitor::walkOnX3DNode(X3DNode *N, SFNode Child) const
{
  //return true;
  return !(globalVariables->getHasUSE());  
}

void SceneToFileCoreVisitor::leaveX3DNode(X3DNode *N) const
{
  globalVariables->removeTab();
  
  if (globalVariables->hasChild())
    globalVariables->writeOpeningLine("/>");  
  else
  {
    globalVariables->writeOpeningLine(">");
    globalVariables->newLine();
    globalVariables->writeCurrentLine("</" + N->getName() + ">");
  }  
  
  globalVariables->popLine();
  globalVariables->popHasUSE();  
}

